require 'bundler'
require 'gemfilings/gemfile'

module  Gemfilings
module  Commands
class   Gem
  def initialize(options = {}, gem_names)
    self.toggle_path = options[:toggle_path]
    self.gemfile     = options[:gemfile]
    self.gem_names   = Array(gem_names)
  end

  def call
    if toggle_path
      gemfile.toggle_local_path(gem_names)
    end

    `bundle install`
  end

  def self.call(options = {}, gem_names)
    new(options, gem_names).call
  end

  protected

  attr_accessor :toggle_path,
                :gemfile,
                :gem_names

  def gemfile=(other)
    @gemfile = Gemfile.new(File.expand_path(other || 'Gemfile'))
  end
end
end
end
