require 'pathname'

module  Gemfilings
class   Gemfile
  def initialize(path)
    self.path               = path
    self.file               = File.read(path)
    self.projects_directory = Pathname.new(ENV['PROJECTS_HOME'])
  end

  def toggle_local_path(gem_names)
    gem_names.each do |gem_name|
      gem_pattern      = /^(\s*gem\s+['"]#{gem_name}['"].*?)(,\s*)?(\s*)(#.*)?$/
      gem_path_pattern = /^(\s*gem\s+['"]#{gem_name}['"].*?)(, path: '([^']+)')/

      local_path = discovered_gem_path(gem_name)

      if file =~ gem_path_pattern
        file.gsub!(gem_path_pattern, '\1')
      else
        file.gsub!(gem_pattern, "\\1, path: '#{local_path}'\\2\\3\\4")
      end

      File.write(path, file)
    end
  end

  protected

  attr_accessor :path,
                :file,
                :projects_directory

  def discovered_gem_path(gem_name)
    Pathname.
      glob("#{projects_directory}/{,*/,*/*/}#{gem_name}", File::FNM_EXTGLOB).
      first
  end
end
end
